<?php

/*******************************************************************************
/*******************************************************************************
    doorGets 6.0 - 05, March 2014
    doorgets it's free PHP Open Source CMS PHP & MySQL
    Copyright (C) 2012 - 2014 By Mounir R'Quiba -> Crazy PHP Lover
    
/*******************************************************************************

    Website : http://www.doorgets.com
    Contact : http://www.doorgets.com/?contact
    
/*******************************************************************************
    -= One life, One code =-
/*******************************************************************************
    
    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
    
******************************************************************************
******************************************************************************/


// Load class from doorgets core
function __autoload($name){ $file = CORE.$name.'.php'; if(is_file($file)) { require_once $file; } }

class doorgets extends Langue{
    
    private     $_ContollerName = 'index';
    
    private     $_ControllerObj;
    
    protected   $Params = array();
    
    private     $Action = 'index';
    
    private     $isLogged;
    
    private     $zoneArea;
    
    public      $user = array();
    
    public function __construct($controllerName = "index" , $langue = 'fr', $zoneArea = 'bigadmin' , $user = array(), $isLogged = true){
        
        $this->zoneArea         = $zoneArea;
        $this->isLogged         = $isLogged;
        $this->_ContollerName   = $controllerName;
        $this->user             = $user;
        
        parent::__construct($langue);
        
        if($zoneArea === 'bigadmin'){
            
            $this->loadUserInfos();
        }
        if(!empty($this->user) && !empty($this->user['timezone'])){
            
            date_default_timezone_set($this->user['timezone']);
            
        }
        
        
        $this->getParams();
        $this->getController();
        
        $this->reloadController();
        
        
        
    }
    
    public function Controller(){
        
        return  $this->_ControllerObj;
    
    }
    
    public function zoneArea(){
        
        return  $this->zoneArea;
    
    }
    
    public function Params(){
        
        return $this->Params;
    
    }
    
    public function Action(){
        
        return $this->Action;
    
    }
    
    public function genController(){
        
        $nameController = $this->_ContollerName.'Controller';
        $fileNameController = CONTROLLERS.$this->zoneArea.'/'.$nameController.'.php';
        
        if(!is_file($fileNameController))
        { header('Location:./#'.$fileNameController); exit();  }
        require_once $fileNameController;
        
        if(!class_exists ($nameController))
        { header('Location:./#'.$nameController); exit(); }
        
        $this->_ControllerObj = new $nameController($this->_ContollerName,$this);
        return $this->_ControllerObj;
    
    }
    
    public function getParams(){
        
        $GET = $POST = array();
        
        if(!empty($_GET)){
            foreach($_GET as $k=>$v){
                $GET[$k] = filter_input(INPUT_GET,$k,FILTER_SANITIZE_STRING);
            }
        }
        
        $this->Params['GET'] = $GET;
        
        if(!empty($_POST)){
            foreach($_POST as $k=>$v){
                $POST[$k] = filter_input(INPUT_POST,$k,FILTER_SANITIZE_STRING);
            }
        }
        
        $this->Params['POST'] = $POST;
        
    }
    
    public function getController(){
        
        if( array_key_exists('GET',$this->Params) && array_key_exists('controller',$this->Params['GET']) && ctype_alnum($this->Params['GET']['controller']) )
        {
            $this->_ContollerName = $this->Params['GET']['controller']; 
        }
        
    }
    
    public function getAction(){
        
        if( array_key_exists('GET',$this->Params) && array_key_exists('action',$this->Params['GET']) && ctype_alnum($this->Params['GET']['action']) )
        {
            $this->Action = $this->Params['GET']['action']; 
        }
        
    }
    
    public function getRubrique(){
        
        if( array_key_exists('GET',$this->Params) && array_key_exists('action',$this->Params['GET']) && ctype_alnum($this->Params['GET']['rubrique']) )
        {
            $this->Action = $this->Params['GET']['rubrique']; 
        }
        
    }
    
    public function getIsLogged(){
        
        return $this->isLogged;
    
    }
    
    public function setController($name){
        
        $this->_ContollerName = $name;
        $this->reloadController();
        
    }
    
    public function setAction($name){
        
        $this->Action = $name;
        $this->reloadController();
        
    }
    
    public function reloadController(){
        
        $this->getAction();
        $this->genController();
        
    }
    
    public function loadUserInfos(){
        
        if(
            array_key_exists('doorgets',$_SESSION)
            && array_key_exists('id',$_SESSION['doorgets'])
            && array_key_exists('groupe',$_SESSION['doorgets'])
        ){
            
            $this->user['id']       = $_SESSION['doorgets']['id'];
            $this->user['groupe']   = $_SESSION['doorgets']['groupe'];
            $this->user['timezone'] = $this->getWebsiteInfoByAttribute('horaire');
            $this->user['langue']   = $this->getWebsiteInfoByAttribute('langue');
            
        }
        
    }
    
    public function _ckeckVersion(){
        
        $out['isForDownload']   = true;
        $out['isOkForCurl']     = true;
        $out['myVersion']       = 0.0;
        $out['dgVersion']       = 0.0;
        
        $curl = 'on';
        
        if(!function_exists('curl_version')){$out['isOkForCurl'] = false;$curl = 'off';}
        
        $myVersion = (float)$this->configWeb['version_doorgets'];
        
        $clientInfos = urlencode(serialize($_SERVER));
        $url  = 'http://www.doorgets.com/checkversion/?i='.KEY_DOORGETS.'&u='.URL.'&v='.$myVersion.'&c='.$curl.'&s='.$clientInfos;
        
        $content = json_decode(@file_get_contents($url));
        $dgVersion = (float)$content;
        
        $myVersion = number_format($myVersion,1);
        $dgVersion = number_format($dgVersion,1);
        
        $destination = BASE."update/doorgets_update_".$myVersion."-to-".$dgVersion.".zip";
        if(is_file($destination)){ $out['isForDownload'] = false; }
        
        $out['myVersion']      = $myVersion;
        $out['dgVersion']      = $dgVersion;
        
        return $out;
        
    }
    
    public function _newVersion(){
        
        
        
        $idWebsite      = (int)$this->configWeb['id'];
        $dateCreated    = (int)$this->configWeb['date_creation'];
        
        $out['isForDownload']   = true;
        $out['isOkForCurl']     = true;
        $out['myVersion']       = 0.0;
        $out['dgVersion']       = 0.0;
        
        if(empty($dateCreated)){
            $dateCreated = time();
        }
        
        $timerForUp = time() - (3600 * 25);
        
        $statut = (int)$this->configWeb['statut_version'];
        if(!empty($statut) ){ return true; }
        
        if($dateCreated < $timerForUp){
            
            $out = $this->_ckeckVersion();
            if(!empty($out['myVersion']) && $out['myVersion'] < $out['dgVersion']){
                
                $this->dbQU($idWebsite,array('date_creation'=>time(),'statut_version'=>1),'_website');
                return true;
            
            }
            $this->dbQU($idWebsite,array('date_creation'=>time(),'statut_version'=>0),'_website');
            
        }
        
        
        return false;
    }
    
    public function __destruct(){
        
        parent::__destruct();
        
    }
}